      program boost_test
****************************************************************************
* To test boosting performace 
* By Haijun Yang @ University of Michigan, Feb. 25, 2004
****************************************************************************
      include 'boost-test.inc'
      include 'hbookboost.inc'
      
      real tree_combined(nevt) ! nb - # of boosting
      integer itr,ib,icheck,jcut
      real tree_all(nb,nevt)

c      real vnum, vcut, vlr
*---> initialization
      call vzero(dat_test,nvar*nevt)
      call vzero(tree_all,nb*nevt)
      call vzero(purity_left,node_max*ntr_max*nb)
      call vzero(purity_right,node_max*ntr_max*nb)
      call vzero(next_right_node,node_max*ntr_max*nb)
      call vzero(next_left_node,node_max*ntr_max*nb)
      call vzero(node_var,node_max*ntr_max*nb)
      call vzero(node_val,node_max*ntr_max*nb)
      call vzero(alpha,ntr_max*nb)

* open ntp file
      CALL HLIMIT(NWPAWC)

      CALL PLOT(1)
      
*---> read in test samples
      CALL readin_dat
      
* readin leaf_index info
      do ich = 1, 1

      call readin_treeindex(ich)
      
      alpha_tot = 0
*---  > estimate signal/background
      if(ada_or_epsilon(ich).eq.-1) then
         print *, 'epsilon boost= ',epsilon(ich)
      else
         print *, 'adaboost = ',beta(ich)
      endif
      print *, 'tree/leaf # = ',ntr(ich), node(ich)
      print *, 'nevt_test = ',nevt_test
      print *, 'purity_cut = ', purity_cut
      
*--- test binary tree          
      call vzero(tree_combined,nevt)
      do itr = 1, ntr(ich)
         call vzero(tree_index,nevt*nb)
         do i = 1, nevt_test
            next_node = 1
 555        continue
            if(dat_test(node_var(next_node,itr,ich),i)
     &           .lt.node_val(next_node,itr,ich)) then !  goto left node
               purity = purity_left(next_node,itr,ich)
               next_node = next_left_node(next_node,itr,ich)
            else                ! goto right node
               purity = purity_right(next_node,itr,ich)
               next_node = next_right_node(next_node,itr,ich)                 
            endif
            
c     print *, 'next_node = ', next_node
            if(next_left_node(next_node,itr,ich).ne.no_node) goto 555
            
C     here if at an ending node               
            if(purity.gt.purity_cut(ich)) then
               tree_index(i,ich) = 1
            else
               tree_index(i,ich) = -1
            endif
            
c     print *, 'tree_index(',i,')=',tree_index(i,ich)

         enddo                  ! end event iteration
         
*--- combine all tree information and check purity of existing trees
         do i = 1, nevt_test
            tree_combined(i)=tree_combined(i)+
     &           tree_index(i,ich)*alpha(itr,ich)
         enddo
         
         alpha_tot = alpha_tot + alpha(itr,ich)

c     print *, 'alpha_tot', alpha_tot

         if(mod(itr,10).eq.0) then
            call check_purity(itr,tree_combined)
         endif
         
      enddo                     ! end tree iteration
         
      do i = 1, nevt_test
         tree_all(ich,i) = tree_combined(i)
      enddo

      enddo                     ! end ich loop
      
*---  > close ntuple

      CALL PLOT(3)
      
*                                                end boost_test
      end
****************************************************************************
      subroutine readin_treeindex(ich)
****************************************************************************
      include 'boost-test.inc'
      integer ich
*---- initialization

      open(25,file='treeindex.dat',status='old')

      read(25,8800) dratio(ich), sigeff(ich), ntr2(ich),
     &              nevt1(ich), nevt2(ich),
     &              nsig_train(ich), nbkgd_train(ich),
     &              node(ich), ntr(ich),
     &              epsilon(ich), beta(ich), 
     &              purity_cut(ich), ada_or_epsilon(ich)
      
      read(25,8801) (alpha(itr,ich),itr=1,ntr(ich))
      
      do itr = 1, ntr(ich)
         do inode = 1, node(ich)
            read(25,8802)
     &           purity_right(inode,itr,ich),
     &           purity_left(inode,itr,ich),
     &           next_right_node(inode,itr,ich),
     &           next_left_node(inode,itr,ich),
     &           node_var(inode,itr,ich),
     &           node_val(inode,itr,ich)
         enddo
      enddo
      
 8800 format(2(1x,f10.2),7(1x,I10),4(1x,f10.5))
 8801 format(10(1x,E12.5))
 8802 format(2(1x,E12.5),3(1x,I12),(1x,E12.5))
      close(25)
      
*                                                   end readin_leafindex
      end
****************************************************************************
****************************************************************************
      subroutine readin_dat
****************************************************************************
* dat_test(nvar,i) = 1  -> signal
*                  = -1 -> mu ccqe
*                  = -2 -> mu like
*                  = -3 -> pi like
*                  = -4 -> nc pi0
****************************************************************************

      include 'boost-test.inc'
      real dat_tmp(nvar)
      integer nbkgd_test_tmp

*---> initialization
      call vzero(dat_test,nvar*nevt)

*---> read in test samples
      open(21,file='test.dat',status='old')
      do i = 1, nevt
         if(i.eq.1) read(21,*) nsig_test, nbkgd_test_tmp
         read(21,*,end=100) (dat_test(ivar,i),ivar=1,nvar-2)                  
 
         dat_test(nvar-1,i) = 0
         if(i.le.nsig_test) then ! signal
            dat_test(nvar,i) = 1
         elseif(i.gt.nsig_test) then ! background
            dat_test(nvar,i) = -1
         endif            
      enddo
 100  close(21)
      ntot_test = i - 1  
      nevt_test = ntot_test
      nbkgd_test = nbkgd_test + nbkgd_test_tmp
      print *,'TOTAL/SGNL/BKGD_test=',nevt_test,nsig_test,nbkgd_test

*                                                  end readin_dat     
      end
****************************************************************************
      SUBROUTINE PLOT(IFLAG)
****************************************************************************
      include 'hbookboost.inc'

      INTEGER IFLAG
      INTEGER IFILE

*---> book ntpl/hist
      IF(IFLAG.EQ.1) THEN
c         CALL HLIMIT(NWPAWC)
         CALL HCDIR('//PAWC',' ')
         call hropen(2,'RWN','boost-test.ntp','N',1024,ISTAT)
         call hbookn(10,'boosting performance',NVAR1,'RWN',1024,CH)
c         call hbookn(11,'spliting variables',NVAR2,'RWN',1024,CH2)
         call hbookn(12,'signal probability',NVAR3,'RWN',1024,CH3)
      ENDIF

*---> fill
      IF(IFLAG.EQ.2) THEN

      ENDIF

*---> close ntpl
      IF(IFLAG.EQ.3) THEN
        call hcdir('//RWN',' ')
        call hrout(0,icycle,' ')
        call hrend('RWN')
      ENDIF

*                                           END PLOT
      END
****************************************************************************
      subroutine check_purity(itr,tree_combined)
* to estimate double ratio vs. signal efficiency and to save in ntuples
****************************************************************************
      include 'boost-test.inc'
      include 'hbookboost.inc'
      integer itr
      real tree_combined(nevt)
      real treecomb_tmp, prob_sig
      real eff, purity, effbg, effratio
      real pt, factor, sig_tmp, sig_tot, tot_tmp

      iepsilon = 0
      
      if(iepsilon.eq.1) then  ! epsilon boosting algorithm
         factor = 1.
         step = 2.
      else ! adaboosting algorithm
         factor = alpha_tot/real(itr)
         step = 1.
      endif
      print *, 'factor/step = ',factor,step
      print *, 'nevt/nsig = ',nevt_test,nsig_test,nbkgd_test,itr

      do pt = 0, itr, step  ! for different signal efficiency
         sig_tmp = 0.
         sig_tot = 0.
         tot_tmp = 0.
            
         do i = 1, nsig_test + nbkgd_test
            if(tree_combined(i).ge.pt*factor) then
               tot_tmp = tot_tmp + 1.
               if(i.le.nsig_test) then
                  sig_tmp = sig_tmp + 1.
               endif
            endif
         enddo

c         print *, tot_tmp, sig_tmp, nsig_test, nbkgd_test
*---- compute eff, purity, error rate and ratio (Ns/sqrt(N_bg))

         eff = 100.*sig_tmp/real(nsig_test) ! fraction of signal kept
         purity = 100.*sig_tmp/tot_tmp
         effbg = real(tot_tmp-sig_tmp)/real(nbkgd_test) ! fraction of bkgd kept
         effratio = 100*100.*effbg/eff
         ratio = eff/100.*purity/(100.-purity) ! compute ratio based on S^2/bg
         if(eff.gt.0.) then
            print *, 'tree#/eff/purity/err_ratio (%)=',
     &           itr,eff,purity,effratio
         endif

         array(1) = itr
         array(2) = eff
         array(3) = purity
         array(4) = effratio           
         call hfn(10,array)
      enddo


*---- save signal probability for each 100 tree iterations
c      goto 991
      if(mod(itr,10).eq.0) then
         do i = 1, nevt_test
            treecomb_tmp = 0.
            prob_sig = 0.
            
            treecomb_tmp = tree_combined(i)/10.
c            prob_sig = 1./(1.+exp(-2.*treecomb_tmp)) ! signal probability estimation


            array3(1) = itr
            array3(2) = dat_test(50,i) ! energy
            array3(3) = dat_test(51,i) ! radius to tank center
            array3(4) = dat_test(52,i) ! r to tank wall
            array3(5) = tree_combined(i) ! probability to be a signal for each test event
            array3(6) = dat_test(nvar,i) ! 1 for signal, < 0 for background

            call hfn(12,array3)
         enddo
      endif
 991  continue      
c                                                           end check_purity
      end


****************************************************************************
****************************************************************************
****************************************************************************
****************************************************************************
****************************************************************************
****************************************************************************
